#include "Seznam.h"
Seznam::Seznam()
{
	hlava = new Prvek();
	zarazka = hlava;
}
void Seznam::pridejNaZacatek(T data)
{
	Prvek* novyPrvek = new Prvek();
	novyPrvek->nastavData(data);
	novyPrvek->nastavDalsi(hlava);
	hlava = novyPrvek;
}
void Seznam::pridejNaKonec(T data)
{
	Prvek* novaZarazka = new Prvek();
	zarazka->nastavData(data);
	zarazka->nastavDalsi(novaZarazka);
	zarazka = novaZarazka;
}
bool Seznam::jePrazdny()
{
	return hlava == zarazka;
}
void Seznam::odstranPrvni()
{
	Prvek* prvniPrvek = hlava;
	hlava = prvniPrvek->vratDalsi();
	delete prvniPrvek;
}
void Seznam::odstranPosledni()
{
	Prvek* posledniPrvek = hlava;
	while(posledniPrvek->vratDalsi() != zarazka)
	{
		posledniPrvek = posledniPrvek->vratDalsi();
	}
	delete zarazka;
	zarazka = posledniPrvek;
}
void Seznam::vyprazdni()
{
	while(!jePrazdny())
	{
		odstranPrvni();
	}
}
Prvek* Seznam::najdiPrvek(T data)
{
	Prvek* nalezenyPrvek = hlava;
	zarazka->nastavData(data);
	while(nalezenyPrvek->vratData() != data)
	{
		nalezenyPrvek = nalezenyPrvek->vratDalsi();
	}
	if(nalezenyPrvek == zarazka)
	{
		return nullptr;
	}
	else
	{
		return nalezenyPrvek;
	}
}
void Seznam::vypis()
{
	Prvek* aktualniPrvek = hlava;
	while(aktualniPrvek != zarazka)
	{
		cout << aktualniPrvek->vratData() << ", ";
		aktualniPrvek = aktualniPrvek->vratDalsi();
	}
	cout << endl;
}
Seznam::~Seznam()
{
	vyprazdni();
	delete hlava;
}
